# abgerundetesRechteck.py

from grafikfenster import *

from figur import Figur

### ---------------------------------------------------
class AbgerundetesRechteck(Figur):
    """Klasse Rechteck ermoeglicht das Zeichnen
    und Bearbeiten eines Rechtecks"""

    def __init__(self,
                 xPos=0,
                 yPos=0,
                 breite=200,
                 hoehe=80,
                 winkel=0,
                 farbe="black",
                 fuellfarbe = None):
        Figur.__init__(self, xPos, yPos, breite, hoehe, winkel, farbe, fuellfarbe)
        self.radiusAnteil=0.1

    def SetzeRadiusAnteil(self, anteil):
        '''setzt den Anteil der halben Kante, die fuer den Bogen verwendet wird'''
        self.radiusAnteil=anteil
        
        
    def GibFigur(self):
        """Definiert den Pfad und transformiert ihn."""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        
        # lokale Variable zur Schreibvereinfachung
        b, t = self.GibBreite(), self.GibHoehe()
        radius=self.radiusAnteil*min(b,t)
        path.AddRoundedRectangle(0, 0, b, t,radius)
        
        return self.Transformiere(path)
    
### ---------------------------------------------------
class AbgerundetesRechteckApp(wx.App):
    """Test-Anwendung speziell fuer Sessel"""
    def OnInit(self):
        self.__fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.__fenster)
        self.__fenster.Show(True)
        self.__fenster.panel.Refresh()
        self.TestAnwendung()
        self.__fenster.ZeigeShellFrame()
        #self.__fenster.ZeigeFillingFrame()
        return True

    def TestAnwendung(self):
        # Allein fuer die Testanwendung:
        global rechteck
        rechteck=AbgerundetesRechteck(200, 40, 100, 60, 90, 'black', None)

### ---------------------------------------------------
if __name__ == '__main__':
    app = AbgerundetesRechteckApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
