# bogen.py

from grafikfenster import *

from figur import Figur

from math import pi

### ---------------------------------------------------
class Bogen(Figur):
    """Die Klasse Bogen ermoeglicht das Zeichnen
    und Bearbeiten eines Bogens"""

    def __init__(self,
                 mitteX=50,
                 mitteY=50,
                 radius=60,
                 winkelStart=10,
                 winkelEnde=170,
                 farbe="BLACK",
                 fuellfarbe=None):
        self.__mX, self.__mY, self.__r  = mitteX, mitteY, radius
        self.__grundfigur = None
        # Die winkel muessen auf Bogenmass umgerechnet werden
        self.__wS, self.__wE = winkelStart*pi/180, winkelEnde*pi/180
        Figur.__init__(self, self.__mX, self.__mY, 0, 0, 0, farbe, fuellfarbe)

    def _SetzeGrundfigur(self):
        """Definiert den Pfad ohne Transformation"""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        #AddArc(wxDouble x, wxDouble y, wxDouble r,
        # wxDouble startAngle, wxDouble endAngle, bool clockwise)
        path.AddArc(0, 0, self.__r, self.__wS, self.__wE, True)
        box=path.GetBox()
        # Fuer die Transformation:
        self._Figur__breite = box.width
        self._Figur__hoehe = box.height
        return path
        
    def GibFigur(self):
        """Uebergibt den Pfad der Transformation"""
        if self.__grundfigur == None:
            self.__grundfigur = self._SetzeGrundfigur()
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        path.AddPath(self.__grundfigur)
        return self.Transformiere(path)
    
### ---------------------------------------------------
class BogenApp(wx.App):
    """Test-Anwendung"""
    def OnInit(self):
        self.__fenster = GrafikFenster(None, "Figuren-Grafik")
        self.SetTopWindow(self.__fenster)
        self.__fenster.Show(True)
        self.__fenster.panel.Refresh()
        self.TestAnwendung()
        self.__fenster.ZeigeShellFrame()
        #self.__fenster.ZeigeFillingFrame()
        return True

    def TestAnwendung(self):
        """Test-Methode speziell fuer Boegen"""
        global b1, b2
        b1=Bogen()
        b2=Bogen(10, 10, 40, 0, 90, 'blue', 'red')

### ---------------------------------------------------
if __name__ == '__main__':
    app = BogenApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
