# einfacherPfeil.py

from grafikfenster import *

from figur import Figur
from figurenGruppe import FigurenGruppe

class EinfacherPfeil(Figur):
    """Muster: -->"""
    
    def __init__(self,
                 xPos=0,
                 yPos=140,
                 laenge=100,
                 winkel=0,
                 farbe="black",
                 breiteFaktor=0.02):
        self.__bF=breiteFaktor
        Figur.__init__(self, xPos, yPos, laenge, 0, winkel, farbe, None)

    def AendereFuellfarbe(self, neueFuellfarbe=None):
        """Linien haben keine Fuellfarbe"""
        pass
        
    def GibFigur(self):
        """Definiert den Pfad und transformiert ihn."""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        
        # lokale Variable zur Schreibvereinfachung
        b, h, bf = self.GibBreite(), self.GibHoehe(), self.__bF
        path.MoveToPoint(0, 0)
        path.AddLineToPoint(b, h)
        path.AddLineToPoint((1-2*bf)*b, -bf*b)
        path.MoveToPoint(b, h)
        path.AddLineToPoint((1-2*bf)*b, bf*b)
        
        return self.Transformiere(path)

    def Transformiere(self, path):
        """Transformiert den übergebenen Pfad
        Drehung um Anfangspunkt! """
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        gc.PushState()
        # Hilfvariable verwenden
        x,y = self.GibXPosition(), self.GibYPosition()
        w = self.GibOrientierung()
        b,h = self.GibBreite(), self.GibHoehe()
        gc.Translate(x, y)
        gc.Rotate(radians(w))
        transformation = gc.GetTransform()
        gc.PopState()
        path.Transform(transformation)
        gruppe=self.GibGruppe()
        if gruppe != None:
            return gruppe.Transformiere(path)
        return path


### ---------------------------------------------------
class PfeilApp(wx.App):
    """Test-Anwendung"""
    def OnInit(self):
        self.__fenster = GrafikFenster(None, "Figuren-Grafik",size=(800, 400))
        self.SetTopWindow(self.__fenster)
        self.__fenster.Show(True)
        self.__fenster.panel.Refresh()
        self.__fenster.ZeigeShellFrame()
        ##self.TestAnwendungArrayDemo()
        ##self.TestAnwendungMVC()
        #self.__fenster.ZeigeFillingFrame()
        return True

    def BildExport(self, dateiname='Diagramm.png'):
        Zeichenflaeche.GibZeichenflaeche().BildExport(dateiname)

    def TestAnwendungMVC(self):
        '''MVC-Diagramm nach Robin Dunn S.127'''
        global gruppe
        from ellipse import Ellipse
        from text import Text
        gruppe=FigurenGruppe(30,30)
        gruppe.FuegeHinzu(EinfacherPfeil(0, 100, 120, 0))
        text3=Text('Ereignis', 50, 110)
        text3.SetzeFont(12)
        gruppe.FuegeHinzu(text3)
        gruppe.FuegeHinzu(Ellipse(520, 0, 100, 100, 0, 'BLACK'))
        text1=Text('Model', 575, 70)
        text1.SetzeFont(12)
        gruppe.FuegeHinzu(text1)
        gruppe.FuegeHinzu(Ellipse(120, 50, 100, 100, 0, 'BLACK'))
        text2=Text('Controller', 165, 120)
        text2.SetzeFont(12)
        gruppe.FuegeHinzu(text2)
        gruppe.FuegeHinzu(EinfacherPfeil(170, 50, 400, -7))
        text2=Text('Senden', 340, 40, -6)
        text2.SetzeFont(12)
        gruppe.FuegeHinzu(text2)
        gruppe.FuegeHinzu(EinfacherPfeil(570, 100, -350, 0))
        text3=Text('Daten-Update', 340, 110)
        text3.SetzeFont(12)
        gruppe.FuegeHinzu(text3)
        gruppe.FuegeHinzu(Ellipse(520, 150, 100, 100, 0, 'BLACK'))
        text4=Text('View', 575, 220)
        text4.SetzeFont(12)
        gruppe.FuegeHinzu(text4)
        gruppe.FuegeHinzu(EinfacherPfeil(170, 150, 400, 0))
        text5=Text('Aufforderung zum Update', 320, 160)
        text5.SetzeFont(12)
        gruppe.FuegeHinzu(text5)
        gruppe.FuegeHinzu(EinfacherPfeil(570, 250, -350, 0))
        text6=Text('Anzeige erneuern', 340, 260)
        text6.SetzeFont(12)
        gruppe.FuegeHinzu(text6)
        self.BildExport("MVC nach Robin Dunn.png")

### ---------------------------------------------------
if __name__ == '__main__':
    app = PfeilApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
