# ellipse.py

from grafikfenster import *

from figur import Figur

### ---------------------------------------------------
class Ellipse(Figur):
    """Klasse Ellipse ermoeglicht das Zeichnen
    und Bearbeiten einer Ellipse"""

    def __init__(self,
                 xPos=0,
                 yPos=0,
                 breite=200,
                 hoehe=80,
                 winkel=0,
                 farbe="black",
                 fuellfarbe=None):
        Figur.__init__(self, xPos, yPos, breite, hoehe, winkel, farbe, fuellfarbe)
        
    def GibFigur(self):
        """Definiert den Pfad und transformiert ihn."""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        
        # lokale Variable zur Schreibvereinfachung
        b, h = self.GibBreite(), self.GibHoehe()
        path.AddEllipse(0, 0, b, h)
        
        return self.Transformiere(path)
    
### ---------------------------------------------------
class EllipseApp(wx.App):
    """Test-Anwendung speziell fuer Sessel"""
    def OnInit(self):
        self.__fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.__fenster)
        self.__fenster.Show(True)
        self.__fenster.panel.Refresh()
        self.TestAnwendung()
        self.__fenster.ZeigeShellFrame()
        #self.__fenster.ZeigeFillingFrame()
        return True

    def TestAnwendung(self):
        # Allein fuer die Testanwendung:
        global e
        e=Ellipse(200, 40, 100, 60, 90, 'red','yellow')

### ---------------------------------------------------
if __name__ == '__main__':
    app = EllipseApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
