# figurenApp.py

from grafikfenster import *

from figur import Figur
from figurenGruppe import FigurenGruppe

### ---------------------------------------------------
class FigurenApp(wx.App):
    """Test-Anwendung"""
    def OnInit(self):
        self.__fenster = GrafikFenster(None, "Figuren-Grafik",size=(800, 400))
        self.SetTopWindow(self.__fenster)
        self.__fenster.Show(True)
        self.__fenster.panel.Refresh()
        self.__fenster.ZeigeShellFrame()
        ##self.TestAnwendungArrayDemo()
        ##self.TestAnwendungMVC()
        #self.__fenster.ZeigeFillingFrame()
        print('interaktiv arbeiten in der PyShell')
        return True

    def BildExport(self, dateiname='Diagramm.png'):
        Zeichenflaeche.GibZeichenflaeche().BildExport(dateiname)

    def TestAnwendungMVC(self):
        '''MVC-Diagramm nach Robin Dunn S.127'''
        global gruppe
        from ellipse import Ellipse
        from text import Text
        from einfacherPfeil import EinfacherPfeil
        gruppe=FigurenGruppe(30,30)
        gruppe.FuegeHinzu(EinfacherPfeil(0, 100, 120, 0))
        text3=Text('Ereignis', 50, 110)
        text3.SetzeFont(12)
        gruppe.FuegeHinzu(text3)
        gruppe.FuegeHinzu(Ellipse(520, 0, 100, 100, 0, 'BLACK'))
        text1=Text('Model', 575, 70)
        text1.SetzeFont(12)
        gruppe.FuegeHinzu(text1)
        gruppe.FuegeHinzu(Ellipse(120, 50, 100, 100, 0, 'BLACK'))
        text2=Text('Controller', 165, 120)
        text2.SetzeFont(12)
        gruppe.FuegeHinzu(text2)
        gruppe.FuegeHinzu(EinfacherPfeil(170, 50, 400, -7))
        text2=Text('Senden', 340, 40, -6)
        text2.SetzeFont(12)
        gruppe.FuegeHinzu(text2)
        gruppe.FuegeHinzu(EinfacherPfeil(570, 100, -350, 0))
        text3=Text('Daten-Update', 340, 110)
        text3.SetzeFont(12)
        gruppe.FuegeHinzu(text3)
        gruppe.FuegeHinzu(Ellipse(520, 150, 100, 100, 0, 'BLACK'))
        text4=Text('View', 575, 220)
        text4.SetzeFont(12)
        gruppe.FuegeHinzu(text4)
        gruppe.FuegeHinzu(EinfacherPfeil(170, 150, 400, 0))
        text5=Text('Aufforderung zum Update', 320, 160)
        text5.SetzeFont(12)
        gruppe.FuegeHinzu(text5)
        gruppe.FuegeHinzu(EinfacherPfeil(570, 250, -350, 0))
        text6=Text('Anzeige erneuern', 340, 260)
        text6.SetzeFont(12)
        gruppe.FuegeHinzu(text6)
        self.BildExport("MVC nach Robin Dunn.png")

    def TestAnwendungArrayDemo(self):
        """Array-Demo"""
        global gruppe
        from rechteck import Rechteck
        from ellipse import Ellipse
        from text import Text
        from einfacherPfeil import EinfacherPfeil
        gruppe=FigurenGruppe(60,60)
        anzahl=5
        gruppe.FuegeHinzu(Ellipse(-10, 0, 80, 40, 0, 'BLACK'))
        gruppe.FuegeHinzu(Text('Array\nName',60+10, 60))
        gruppe.FuegeHinzu(EinfacherPfeil(30, 40, 50, 90, 'BLACK'))
        for i in range(anzahl):
            gruppe.FuegeHinzu(Rechteck(i*60, 90, 60, 60, 0, 'BLACK'))
            gruppe.FuegeHinzu(EinfacherPfeil(30+i*60, 150, 40, 90))
            gruppe.FuegeHinzu(Ellipse(10+i*60, 190, 40, 40))
            gruppe.FuegeHinzu(Text('E '+str(i),60+20+i*60, 60+200))


### ---------------------------------------------------
if __name__ == '__main__':
    app = FigurenApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
