# paketTest.py

import wx
from bogen import Bogen
from ellipse import Ellipse
##from figur import Figur verhindert direkten Aufruf
from figurenGruppe import FigurenGruppe
from grafikfenster import *
from linie import Linie
from nEck import N_Eck
from rechteck import Rechteck
from text import Text
### ---------------------------------------------------
class PaketTestApp(wx.App):
    """Test-Anwendung"""
    def OnInit(self):
        self.__fenster = GrafikFenster(None, "Figuren-Grafik")
        self.SetTopWindow(self.__fenster)
        self.__fenster.Show(True)
        self.__fenster.panel.Refresh()
        self.__fenster.ZeigeShellFrame()
        self.TestAnwendung()
##        self.TestAnwendung2()
##        self.TestAnwendung3()
##        self.TestAnwendung4()
##        self.TestAnwendung5()
##        self.TestText()
##        self.TestWaschbecken()
##        self.TestKlo_1()
##        self.TestKlo_2()
        ##self.__fenster.ZeigeFillingFrame()
        return True

    def BildExport(self, dateiname='Diagramm.png'):
        Zeichenflaeche.GibZeichenflaeche().BildExport(dateiname)

    def TestAnwendung(self):
        """Test-Methode speziell fuer Gruppen"""
        global gruppe, e1, e2, r1, r2
        gruppe=FigurenGruppe(120,170)
        r1=Rechteck(0, 0, 100, 60, 0, 'BLACK')
        gruppe.FuegeHinzu(r1)
        e1=Ellipse(0, 0, 100, 60, 0, 'RED')
        gruppe.FuegeHinzu(e1)
        e2=Ellipse(12.5, 7.5, 75, 45, 0, 'BLUE',(255,255,15))
        gruppe.FuegeHinzu(e2)
        r2=Rechteck(20, 20, 100, 60, 0, (0,200,0))
        gruppe.FuegeHinzu(r2)
        b=Bogen(farbe="RED")
        gruppe.FuegeHinzu(b)
        l=Linie()
        gruppe.FuegeHinzu(l)

    def TestAnwendung2(self):
        """Test-Methode speziell fuer einen Pfeil"""
        global gruppe2, pfeil, kreis
        gruppe2=FigurenGruppe(10,40)
        kreis=Ellipse(0, 0, 30, 30, 0, 'BLUE','YELLOW')
        kreis.AendereFuellfarbe('muschi') ## Test, ob der Fehler abgefangen wird
        gruppe2.FuegeHinzu(kreis)
        pfeil=N_Eck(7,5,((0,0),(20,10),(0,20),(10,10)))
        pfeil.AendereFarbe('black')
        pfeil.AendereFuellfarbe('blue')
        gruppe2.FuegeHinzu(pfeil)
        gruppe2.Skaliere(5)

    def TestAnwendung3(self):
        """Test-Methode speziell fuer einen Pfeil"""
        global gruppe3, pfeil, kreis
        gruppe3=FigurenGruppe(60,40)
        kreis=Ellipse(0, 0, 30, 30, 0, 'red')
        kreis.AendereFarbe('mukuh') ## Test, ob der Fehler abgefangen wird
        kreis.AendereFuellfarbe('GREEN')
        gruppe3.FuegeHinzu(kreis)
        pfeil=N_Eck(7,5,((0,0),(15,7),(15,0),(17,0),(17,20),(15,20),(15,13),(0,20)))
        pfeil.AendereFarbe('black')
        pfeil.AendereFuellfarbe('blue')
        gruppe3.FuegeHinzu(pfeil)
        gruppe3.Skaliere(5)

    def TestAnwendung4(self):
        """Test-Methode speziell fuer einen Pfeil"""
        global gruppe4, pfeil, kreis
        gruppe4=FigurenGruppe(10,80)
        kreis=Ellipse(0, 0, 30, 30, 0, 'black')
        kreis.AendereFarbe('black')
        kreis.AendereFuellfarbe("red")
        gruppe4.FuegeHinzu(kreis)
        pfeil=N_Eck(7,5,((0,0),(20,10),(0,20),(10,10)))
        pfeil.AendereFarbe('black')
        pfeil.AendereFuellfarbe((64,64,64,127)) # Test auf Transparenz
        gruppe4.FuegeHinzu(pfeil)
        gruppe4.Skaliere(5)

    def TestAnwendung5(self):
        """Test-Methode speziell fuer einen Pfeil"""
        global gruppe5, pfeil, kreis
        gruppe5=FigurenGruppe(60,80)
        kreis=Ellipse(0, 0, 30, 30, 0, 'black')
        kreis.AendereFuellfarbe('light gray')
        gruppe5.FuegeHinzu(kreis)
        pfeil=N_Eck(7,5,((0,0),(15,7),(15,0),(17,0),(17,20),(15,20),(15,13),(0,20)))
        pfeil.AendereFarbe('black')
        pfeil.AendereFuellfarbe('gray')
        gruppe5.FuegeHinzu(pfeil)
        gruppe5.Skaliere(5)

    def TestText(self):
        # Allein fuer die Testanwendung:
        global text0,text1,text2
        text0=Text("Grafikfenster",20,250,90,'BLUE')
        text1=Text("Testtext", 200, 40, 0, 'LIGHT BLUE')
        text1.SetzeFont(18,"ROMAN","KURSIV","NORMAL",True)
        text2=Text("2. Testtext", 200, 140)

    def TestDusche(self):
        global dusche, aussen, innen, ablauf
        dusche=FigurenGruppe(60,60)
        aussen=Rechteck(breite=80,hoehe=80)
        dusche.FuegeHinzu(aussen)
        innen=Rechteck(10,10,breite=60,hoehe=60)
        dusche.FuegeHinzu(innen)
        ablauf=Ellipse(60,60,breite=10,hoehe=10)
        dusche.FuegeHinzu(ablauf)
        
    def TestWaschbecken(self):
        global becken, aussen, innen, ablauf
        becken=FigurenGruppe(60,60)
        aussen=Rechteck(breite=60,hoehe=50)
        becken.FuegeHinzu(aussen)
        innen=Rechteck(2,10,breite=56,hoehe=38)
        becken.FuegeHinzu(innen)
        ablauf=Ellipse(25,12,breite=10,hoehe=10)
        becken.FuegeHinzu(ablauf)
        
    def TestKlo_1(self):
        global klo, becken, sitz
        klo=FigurenGruppe(60,60)
        becken=Rechteck(breite=40,hoehe=40,fuellfarbe = "white")
        klo.FuegeHinzu(becken)
        sitz=Ellipse(0,17,breite=40,hoehe=43,fuellfarbe = "white")
        klo.FuegeHinzu(sitz)
        
    def TestKlo_2(self):
        global klo, becken, sitz
        klo=FigurenGruppe(60,60)
        spuelkasten=Rechteck(breite=40,hoehe=10,fuellfarbe = "white")
        klo.FuegeHinzu(spuelkasten)
        becken=Rechteck(0,10,breite=40,hoehe=40,fuellfarbe = "white")
        klo.FuegeHinzu(becken)
        sitz=Ellipse(0,27,breite=40,hoehe=43,fuellfarbe = "white")
        klo.FuegeHinzu(sitz)
        
        
### ---------------------------------------------------
if __name__ == '__main__':
    app = PaketTestApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
