# linie.py

from grafikfenster import *

from figur import Figur

### ---------------------------------------------------
class Linie(Figur):
    """Klasse Linie ermoeglicht das Zeichnen
    und Bearbeiten einer Linie"""

    def __init__(self,
                 xPos=0,
                 yPos=140,
                 breite=100,
                 hoehe=0,
                 winkel=0,
                 farbe="brown"):
        Figur.__init__(self, xPos, yPos, breite, hoehe, winkel, farbe, None)

    def AendereFuellfarbe(self, neueFuellfarbe=None):
        """Linien haben keine Fuellfarbe"""
        pass
        
    def GibFigur(self):
        """Definiert den Pfad und transformiert ihn."""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        
        # lokale Variable zur Schreibvereinfachung
        b, h = self.GibBreite(), self.GibHoehe()
        path.MoveToPoint(0, 0)
        path.AddLineToPoint(b, h)
        
        return self.Transformiere(path)
    
### ---------------------------------------------------
class LinieApp(wx.App):
    """Test-Anwendung speziell fuer Sessel"""
    def OnInit(self):
        self.__fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.__fenster)
        self.__fenster.Show(True)
        self.__fenster.panel.Refresh()
        self.TestAnwendung()
        self.__fenster.ZeigeShellFrame()
        #self.__fenster.ZeigeFillingFrame()
        return True

    def TestAnwendung(self):
        # Allein fuer die Testanwendung:
        global linie
        linie=Linie(200, 40, 100, 60, 0, 'blue')

### ---------------------------------------------------
if __name__ == '__main__':
    app = LinieApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
