# nEck.py

from grafikfenster import *

from figur import Figur

# Hilfsfunktionen
first = lambda p: p[0]
second = lambda p: p[1]

### ---------------------------------------------------
class N_Eck(Figur):
    """Klasse Linie ermoeglicht das Zeichnen
    und Bearbeiten eines n-Ecks"""

    def __init__(self,
                 xPos=100,
                 yPos=100,
                 ecken=((0,0),(20,10),(0,20)),
                 winkel=0,
                 farbe="brown",
                 fuellfarbe='yellow'):
        self.__ecken=ecken
        breite = max(map(first,ecken)) - min(map(first,ecken))
        hoehe = max(map(second,ecken)) - min(map(second,ecken))
        Figur.__init__(self, xPos, yPos, breite, hoehe, winkel, farbe, fuellfarbe)

    def GibFigur(self):
        """Definiert den Pfad."""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        
        # lokale Variable zur Schreibvereinfachung
        b, h = self.GibBreite(), self.GibHoehe()
        path.MoveToPoint(self.__ecken[0])
        for i in range(1,len(self.__ecken)):
            path.AddLineToPoint(self.__ecken[i])
        path.CloseSubpath()
        
        return self.Transformiere(path)
    
### ---------------------------------------------------
class N_EckApp(wx.App):
    """Test-Anwendung"""
    def OnInit(self):
        self.__fenster = GrafikFenster(None, "Figuren-Grafik")
        self.SetTopWindow(self.__fenster)
        self.__fenster.Show(True)
        self.__fenster.panel.Refresh()
        self.TestAnwendung()
        self.__fenster.ZeigeShellFrame()
        #self.__fenster.ZeigeFillingFrame()
        return True

    def TestAnwendung(self):
        """Test-Methode speziell fuer N_Ecke"""
        global nEck
        nEck=N_Eck(30,30,((0,0),(20,10),(0,20),(3,10)))

### ---------------------------------------------------
if __name__ == '__main__':
    app = N_EckApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
